unit MathBas;
interface

{$J-}
const Eps = 1E-11;
      P2  = 2*Pi;
      P12 = Pi/2;
      Radian :Double = 180/Pi;
      InvRadian :Double = Pi/180;

{  ,      }
function Rad(X:Double):Double;

{  ,      }
function Deg(X:Double):Double;

{  }
function Tan(X:Double):Double;

{  }
function Asn(X:Double):Double;

{  }
function Acs(X:Double):Double;

{   }
function Cubr(X:Double):Double;

{    }
function ATN2(Y,X:Double):Double;

procedure SinCosExt(Theta: Double; var Sin, Cos: Extended) register;

procedure SinCos(Theta: Double; var Sin, Cos: Double);

function Reduce360(Angle :Double) :Double;

function Reduce24(Hour :Double) :Double;

function FloatSqr(Value :Integer) :Double;

function FloatRound(Value :Double; Digits :Integer) :Double;

function Log10(X :double) :double;

implementation

function Rad(X:Double):Double;
asm
   FLD InvRadian
   FMUL X
   WAIT
end;

function Deg(X:Double):Double;
asm
   FLD Radian
   FMUL X
   WAIT
end;

function Tan(X:Double):Double;
asm
   FLD    X
   FPTAN
   FSTP   ST(0)
   FWAIT
end;

function Asn(X:Double):Double;
begin
   Asn := ATN2(X, Sqrt(1 - Sqr(X)))
end;

function Acs(X:Double):Double;
begin
  Acs := ATN2(Sqrt(1 - Sqr(X)), X);
end;

function Cubr(X:Double):Double;
begin
   if X=0.0 then Cubr:=0.0
            else Cubr:=Exp(Ln(X)/3.0)
end;

function ATN2(Y,X:Double):Double;
asm
   FLD     Y
   FLD     X
   FPATAN
   FWAIT
end;

procedure SinCosExt(Theta: Double; var Sin, Cos: Extended);
asm
   FLD     Theta
   FSINCOS
   FSTP    tbyte ptr [edx]
   FSTP    tbyte ptr [eax]
   FWAIT
end;

procedure SinCos(Theta: Double; var Sin, Cos: Double);
var RSin,RCos :Extended;
begin
   SinCosExt(Theta, RSin,RCos);
   Sin := RSin; Cos := RCos
end;

function Reduce360(Angle :Double) :Double;
const Circl360 = 360;
begin
   Reduce360 := Circl360*Frac(Angle/Circl360+4E-20);
   if Result<0 then Result := Result + Circl360
end;

function Reduce24(Hour :Double) :Double;
const Hours24 = 24;
begin
   Reduce24 := Hours24*Frac(Hour/Hours24);
   if Result<0 then Result := Result + Hours24
end;

function FloatSqr(Value :Integer) :Double;
begin
   FloatSqr := Value;
   Result := Sqr(Result)
end;

function FloatRound(Value :Double; Digits :Integer) :Double;
const rnd_k = 5.0/9.0;
var k :Double;
begin
   k := 1;
   while Digits>0 do begin
      k:=k*10; Dec(Digits)
   end;
   FloatRound := Int(Value*k+rnd_k)/k
end;

function Log10(X :double) :double;
begin
   Log10 := 0.43429448190325182765*Ln(X)
end;

end.
